<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="库存地点" prop="storageLocationId">
        <el-select v-model="queryParams.storageLocationId" clearable placeholder="请选择" class="!w-240px">
          <el-option
            v-for="item in storageLocationList"
            :key="item.id"
            :label="item.storageLocationName"
            :value="item.id!"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="库区" prop="storageAreaId">
        <el-select v-model="queryParams.storageAreaId" clearable placeholder="请选择" class="!w-240px">
          <el-option
            v-for="item in storageAreaList"
            :key="item.id"
            :label="item.name"
            :value="item.id!"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="货架" prop="shelvesId">
        <el-select v-model="queryParams.shelvesId" clearable placeholder="请选择" class="!w-240px">
          <el-option
            v-for="item in shelvesList"
            :key="item.id"
            :label="item.name"
            :value="item.id!"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="货位名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入货位名称"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery"><Icon icon="ep:search" class="mr-5px" /> 搜索</el-button>
        <el-button @click="resetQuery"><Icon icon="ep:refresh" class="mr-5px" /> 重置</el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
          v-hasPermi="['pms:iot-cargo-location:create']"
        >
          <Icon icon="ep:plus" class="mr-5px" /> 新增
        </el-button>
        <el-button
          type="success"
          plain
          @click="handleExport"
          :loading="exportLoading"
          v-hasPermi="['pms:iot-cargo-location:export']"
        >
          <Icon icon="ep:download" class="mr-5px" /> 导出
        </el-button>
      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="库存地点" align="center" prop="storageLocationName" />
      <el-table-column label="仓库区域" align="center" prop="storageAreaName" />
      <el-table-column label="货架" align="center" prop="shelvesName" />
      <el-table-column label="货位编码" align="center" prop="code" />
      <el-table-column label="货位名称" align="center" prop="name" />
      <el-table-column
        label="创建时间"
        align="center"
        prop="createTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="操作" align="center" min-width="120px">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
            v-hasPermi="['pms:iot-cargo-location:update']"
          >
            编辑
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
            v-hasPermi="['pms:iot-cargo-location:delete']"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <IotCargoLocationForm ref="formRef" @success="getList" />
</template>

<script setup lang="ts">
import { dateFormatter } from '@/utils/formatTime'
import download from '@/utils/download'
import { IotCargoLocationApi, IotCargoLocationVO } from '@/api/pms/iotcargolocation'
import IotCargoLocationForm from './IotCargoLocationForm.vue'
import * as SapOrgApi from "@/api/system/saporg";
import * as IotStorageAreaApi from "@/api/pms/iotstoragearea";
import * as IotShelvesApi from "@/api/pms/iotshelves";

/** PMS 货位 列表 */
defineOptions({ name: 'IotCargoLocation' })

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const storageLocationList = ref([] as SapOrgApi.SapOrgVO[]) // 库存地点列表
const storageAreaList = ref([] as IotStorageAreaApi.IotStorageAreaVO[]) // 库存地点区域列表
const shelvesList = ref([] as IotShelvesApi.IotShelvesVO[]) // 货架列表

const loading = ref(true) // 列表的加载中
const list = ref<IotCargoLocationVO[]>([]) // 列表的数据
const total = ref(0) // 列表的总页数
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  deptId: undefined,
  factoryId: undefined,
  factoryCode: undefined,
  costCenterId: undefined,
  costCenterCode: undefined,
  storageLocationId: undefined,
  storageLocationCode: undefined,
  storageAreaId: undefined,
  shelvesId: undefined,
  code: undefined,
  name: undefined,
  type: undefined,
  row: undefined,
  layer: undefined,
  columnNumber: undefined,
  capacity: undefined,
  currentUsage: undefined,
  sort: undefined,
  status: undefined,
  remark: undefined,
  createTime: [],
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await IotCargoLocationApi.getIotCargoLocationPage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
  // 加载库存地点(SAP)列表
  storageLocationList.value = await SapOrgApi.SapOrgApi.getSimpleSapOrgList(3)
  // 加载库存地点区域(SAP)列表
  storageAreaList.value = await IotStorageAreaApi.IotStorageAreaApi.getSimpleStorageAreaList()
  // 加载库存地点货架(SAP)列表
  shelvesList.value = await IotShelvesApi.IotShelvesApi.getSimpleShelvesList()
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await IotCargoLocationApi.deleteIotCargoLocation(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {}
}

/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await IotCargoLocationApi.exportIotCargoLocation(queryParams)
    download.excel(data, 'PMS 货位.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
